Subject: Re: bug#25265: make-thread crashes in OS X 10.6

From: Alan Third <[email-masked]>
Date: Mon, 26 Dec 2016 20:56:32 +0000

On Mon, Dec 26, 2016 at 05:52:30PM +0200, Eli Zaretskii wrote:
> > Date: Mon, 26 Dec 2016 13:09:17 +0000
> > From: Alan Third <[email-masked]>
> > Cc: [email-masked], [email-masked]
> > 
> > I’ve just tried the below patch and it doesn’t make any difference: it
> > still hangs immediately.
> 
> Can you try and figure out why it hangs?

I’m not having any luck with this. My entirely uneducated guess is
that the main thread can’t access the contents of current_thread. It
crashes on this line:

    while (specpdl_ptr != specpdl + count)

with EXC_BAD_ACCESS. Only three things are being accessed: count,
which is a function argument, and specpdl and specpdl_ptr are
#defines to variables within current_thread.

I can’t access anything within current_thread using lldb, but I can
see current_thread itself. I don’t know if that signifies anything.

I’ll put the complete backtrace at the bottom of this email.

> > Back in October Ken Raeburn listed some things that need done in
> > ns_select which are probably relevant:
> > 
> > https://lists.gnu.org/archive/html/emacs-devel/2016-10/msg00525.html
> 
> Hmm... none of the changes Ken mentioned were in the concurrency
> branch when I merged it.  Perhaps Ken didn't push the changes back
> then.
> 
> The problems in xg_select were solved in a different way, I believe.
> The problems in ns_select are the issue at hand here.
> 
> Wrt static variables used by ns_select: either they should become
> members of struct thread_state, or the calls to release_global_lock
> and acquire_global_lock should be moved into ns_select (which was what
> Ken was proposing, AFAIU).  I'm not sure which possibility is better,
> nor whether this is all that needs to be done, because I don't
> understand well enough the semantics of some parts of ns_select, in
> particular where it says
> 
>     [NSApp run];
> 
> Can this part and its surrounding code be made thread-safe?

I think this particular method call has to be done *only* from the
main thread. I imagine that could be a problem.

> The call to record_unwind_protect in particular confuses me: that
> seems to hint the code wants to be interruptible here, which might
> require stuff like maybe_reacquire_global_lock I added to
> keyboard.c, to avoid problems when Emacs gets SIGINT on a TTY frame.

-- 
Alan Third